#
#
#	vtmr - formats output of vtmr001.asm captured from the RS232 into .csv format.
#	usage: 
#	bmawk -f vtmr001.awk vtmr001.txt > vtmr001.csv
#
#

#   :A  B  S :        :time,count:
#t88:90+4E=DE:08<90<D8:00C2,0000:
#t88:90+4E=DE:08<90<D8:00C2,0000:

#

BEGIN {
	FS=","
	calc=1
}

{

	# if the measurements are not stable then ignore

	if ( lastLine != $0 ) {
		lastLine = $0
		calc=2
		next
	}

	# if a stable result, only process one result
	if ( calc != 2 ){
		next
	}
	

}


/t/ {
	# set calc=3 to indicate a stable section has bee processed
	calc=3

#   :A  B  S :        :time,count:
#t88:90+4E=DE:08<90<D8:00C2,0000:
#t88:90+4E=DE:08<90<D8:00C2,0000:

#t88:90+4E=DE:08<90<D8:00C2,0000:



 split( $0,f,":")

 a=   hextoint( substr(f[2],1,2) )
 b=   hextoint( substr(f[2],4,2) )
 sum= hextoint( substr(f[2],7,2) )
 time=hextoint( substr(f[4],1,4) )
 calcS= a/sum*300
 error = calcS-time

 print f[2] "," a "," b "," sum "," time "," calcS "," error "," substr(f[4],1,4) "," substr(f[2],1,2) "," substr(f[2],4,2) "," substr(f[2],7,2)
 next
}


/t/ {

 split( $0,f,":")

 a=   hextoint( substr(f[3],1,2) )
 b=   hextoint( substr(f[3],4,2) )
 sum= hextoint( substr(f[3],7,2) )

 print f[3] "," a "," b "," sum "," substr(f[3],1,2) "," substr(f[3],4,2) "," substr(f[3],7,2)
 next
}


{

 split( $0,f,",")

 a=   hextoint( substr(f[1],1,2) )
 b=   hextoint( substr(f[1],4,2) )
 sum= hextoint( substr(f[1],7,2) )

 print f[3] "," a "," b "," sum "," substr(f[3],1,2) "," substr(f[3],4,2) "," substr(f[3],7,2)
 next
}


function hextoint(A  ,d,nc,c) {
	d = 0
	nc = length(A)+1
	for ( c=0 ; c < nc ; c++) {
		d = 16*d+(index("0123456789ABCDEF",substr(A,c,1))-1)
	}
	return d
}




END {
print hextoint("00C2")
print hextoint("01C2")

print hextoint("FFFF")
print hextoint("12345")
print hextoint("54321")
print hextoint("F0")
print hextoint("64")
print hextoint("00F")
print hextoint("")
}
